diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 57928f434..aa7d5dd66 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -3,6 +3,9 @@ package net.minecraft.server;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.achievement.stat.StatList;
@@ -127,14 +130,13 @@ public class MinecraftServer
     public static Logger LOGGER = LogUtils.getLogger();
     public static final String VERSION = Global.VERSION;
     private static MinecraftServer instance;
-    public static HashMap<String, Integer> field_6037_b = new HashMap<>();
 
     public @Nullable Boolean argOffline = null;
     public @Nullable String argWorld = null;
 
     public NetworkListenThread networkServer;
     public PropertyManager propertyManager;
-    public Map<Integer, WorldServer> dimensionWorlds;
+    public Int2ObjectMap<WorldServer> dimensionWorlds;
     public PlayerList playerList;
     private boolean serverRunning;
     public boolean serverStopped;
@@ -143,7 +145,7 @@ public class MinecraftServer
     public int percentDone;
     private final List<IUpdatePlayerListBox> playerListBoxes;
     private final List<ServerCommandEntry> commands;
-    public Map<Integer, EntityTrackerImpl> entityTrackerMap;
+    public Int2ObjectMap<EntityTrackerImpl> entityTrackerMap;
     public boolean onlineMode;
     public boolean pvpOn;
     public boolean allowFlight;
@@ -292,7 +294,7 @@ public class MinecraftServer
             }
         }
 
-        entityTrackerMap = new HashMap<>();
+        entityTrackerMap = new Int2ObjectOpenHashMap<>();
 
         new Registries();
         BiomeProviderOverworld.init();
@@ -360,9 +362,9 @@ public class MinecraftServer
             LOGGER.warn("To change this, set \"online-mode\" to \"true\" in the server.properties file.");
         }
         playerList = new PlayerList(this);
-        for (Map.Entry<Integer, Dimension> entry : Dimension.getDimensionList().entrySet())
+        for (final Int2ObjectMap.Entry<Dimension> entry : Dimension.getDimensionList().int2ObjectEntrySet())
         {
-            entityTrackerMap.put(entry.getKey(), new EntityTrackerImpl(this, entry.getValue()));
+            this.entityTrackerMap.put(entry.getIntKey(), new EntityTrackerImpl(this, entry.getValue()));
         }
         long time = System.nanoTime();
         String lName = argWorld == null ? propertyManager.getStringProperty("level-name", "world") : argWorld;
@@ -506,11 +508,11 @@ public class MinecraftServer
     private void initWorld(ISaveFormat saveFormat, String worldDirName, long l)
     {
         convertWorld(saveFormat, worldDirName);
-        dimensionWorlds = new HashMap<>();
+        dimensionWorlds = new Int2ObjectArrayMap<>();
         SaveHandlerServer saveHandler = new SaveHandlerServer(saveFormat, new File("."), worldDirName, true);
-        for (Map.Entry<Integer, Dimension> entry : Dimension.getDimensionList().entrySet())
+        for (Int2ObjectMap.Entry<Dimension> entry : Dimension.getDimensionList().int2ObjectEntrySet())
         {
-            int dimId = entry.getKey();
+            int dimId = entry.getIntKey();
             Dimension dimension = entry.getValue();
             WorldServer worldServer;
             if (dimId == 0)
@@ -725,21 +727,6 @@ public class MinecraftServer
 
     private void doTick()
     {
-        ArrayList<String> arraylist = new ArrayList<>();
-        for (String s : field_6037_b.keySet()) {
-            int i1 = field_6037_b.get(s);
-            if (i1 > 0) {
-                field_6037_b.put(s, i1 - 1);
-            } else {
-                arraylist.add(s);
-            }
-        }
-
-        for (int i = 0; i < arraylist.size(); i++)
-        {
-            field_6037_b.remove(arraylist.get(i));
-        }
-
         AABB.initializePool();
         Vec3.initializePool();
         deathTime++;
diff --git a/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java b/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java
index 9be2e54b8..6c5a9c75a 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java
@@ -1,5 +1,8 @@
 package net.minecraft.server.entity;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -7,7 +10,6 @@ import net.minecraft.core.net.entity.EntityTrackerEntry;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.PlayerServer;
@@ -19,14 +21,14 @@ import java.util.Set;
 
 public class EntityTrackerImpl implements EntityTracker {
     public final Set<EntityTrackerEntryImpl> trackedEntitySet;
-    public final IntHashMap<EntityTrackerEntryImpl> trackedEntityHashTable;
+    public final Int2ObjectMap<EntityTrackerEntryImpl> trackedEntityHashTable;
     public final MinecraftServer mcServer;
     public final int maxTrackingDistanceThreshold;
     public final Dimension dimension;
 
     public EntityTrackerImpl(MinecraftServer minecraftserver, Dimension dimensions) {
         trackedEntitySet = new HashSet<>();
-        trackedEntityHashTable = new IntHashMap<>();
+        trackedEntityHashTable = new Int2ObjectOpenHashMap<>();
         mcServer = minecraftserver;
         dimension = dimensions;
         maxTrackingDistanceThreshold = minecraftserver.playerList.getMaxTrackingDistance();
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 869dd63f7..d7689c58f 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -1,6 +1,9 @@
 package net.minecraft.server.net;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.objects.ObjectSet;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.data.registry.Registries;
@@ -34,7 +37,7 @@ public class PlayerList
     public static Logger logger = LogUtils.getLogger();
     public List<PlayerServer> playerEntities;
     private final MinecraftServer server;
-    private final Map<Integer, PlayerManager> playerManagers;
+    private final Int2ObjectMap<PlayerManager> playerManagers;
     private final Set<UUID> bans;
     private final Set<String> ipBans;
     private final Set<UUID> ops;
@@ -55,14 +58,14 @@ public class PlayerList
         ipBans = new HashSet<>();
         ops = new HashSet<>();
         whitelist = new HashSet<>();
-        playerManagers = new HashMap<>();
+        playerManagers = new Int2ObjectArrayMap<>();
         this.server = server;
         bansFile = server.getFile("banned-players.txt");
         ipBansFile = server.getFile("banned-ips.txt");
         opsFile = server.getFile("ops.txt");
         whitelistFile = server.getFile("white-list.txt");
         int viewDistance = server.propertyManager.getIntProperty("view-distance", 10);
-        for (Integer dim : Dimension.getDimensionList().keySet())
+        for (int dim : Dimension.getDimensionList().keySet())
         {
             playerManagers.put(dim, new PlayerManager(server, dim, viewDistance));
         }
@@ -104,7 +107,7 @@ public class PlayerList
         }
     }
 
-    public void setPlayerManager(Map<Integer, WorldServer> worldServerMap)
+    public void setPlayerManager(Int2ObjectMap<WorldServer> worldServerMap)
     {
         playerIo = worldServerMap.get(0).getSaveHandler().getPlayerFileData();
     }
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index b39251b7a..3ee1d337c 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -2,6 +2,8 @@ package net.minecraft.server.net.handler;
 
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ShortArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ShortMap;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
@@ -57,7 +59,7 @@ public class PacketHandlerServer extends PacketHandler
     {
         connectionClosed = false;
         hasMoved = true;
-        guiIdMap = new HashMap<>();
+        guiIdMap = new Int2ShortArrayMap();
         mcServer = minecraftserver;
         netManager = networkManager;
         networkManager.setNetHandler(this);
@@ -873,6 +875,6 @@ public class PacketHandlerServer extends PacketHandler
     private double lastPosY;
     private double lastPosZ;
     private boolean hasMoved;
-    private final Map<Integer, Short> guiIdMap;
+    private final Int2ShortMap guiIdMap;
 
 }
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 6356ee414..719b54ce5 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -3,9 +3,10 @@ package net.minecraft.server.world;
 import java.util.ArrayList;
 import java.util.List;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.*;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -25,7 +26,7 @@ public class WorldServer extends World
     public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed)
     {
         super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType);
-        entityIntHashMap = new IntHashMap<>();
+        entityIntHashMap = new Int2ObjectOpenHashMap<>();
         mcServer = minecraftserver;
     }
 
@@ -238,6 +239,6 @@ public class WorldServer extends World
     public ChunkProviderServer chunkProviderServer;
     public boolean dontSave;
     public MinecraftServer mcServer;
-    private final IntHashMap<Entity> entityIntHashMap;
+    private final Int2ObjectMap<Entity> entityIntHashMap;
     private long lastWeatherSend = System.currentTimeMillis();
 }
diff --git a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index e5ba04ba6..f32caa13c 100644
--- a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -1,6 +1,10 @@
 package net.minecraft.server.world.chunk.provider;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
+import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.server.world.WorldServer;
@@ -15,20 +19,20 @@ public class ChunkProviderServer
     implements IChunkProvider
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final Set<Integer> droppedChunksSet;
+    private final IntSet droppedChunksSet;
     private final Chunk emptyChunk;
     public ChunkGenerator chunkGenerator;
     private final IChunkLoader chunkLoader;
     public boolean chunkLoadOverride;
-    private final Map<Integer, Chunk> chunkMap;
+    private final Int2ObjectMap<Chunk> chunkMap;
     private final List<Chunk> chunkList;
     private final WorldServer world;
 
     public ChunkProviderServer(WorldServer world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator)
     {
-        droppedChunksSet = new HashSet<>();
+        droppedChunksSet = new IntOpenHashSet();
         chunkLoadOverride = false;
-        chunkMap = new HashMap<>();
+        chunkMap = new Int2ObjectOpenHashMap<>();
         chunkList = new ArrayList<>();
         emptyChunk = new EmptyChunk(world, 0, 0);
         this.world = world;
@@ -247,7 +251,7 @@ public class ChunkProviderServer
             {
                 if(!droppedChunksSet.isEmpty())
                 {
-                    Integer integer = droppedChunksSet.iterator().next();
+                    int integer = droppedChunksSet.iterator().nextInt();
                     Chunk chunk = chunkMap.get(integer);
                     saveChunkToFile(chunk);
                     chunk.onUnload();
diff --git a/gradle/libs.versions.toml b/gradle/libs.versions.toml
index b3d9e4852..cdbd9729e 100644
--- a/gradle/libs.versions.toml
+++ b/gradle/libs.versions.toml
@@ -5,6 +5,7 @@ lwjgl = "3.3.4"
 [libraries]
 jetbrains-annotations = { module = "org.jetbrains:annotations", version = "24.0.0" }
 gson = { module = "com.google.code.gson:gson", version = "2.10.1" }
+fastutil = { module = "it.unimi.dsi:fastutil", version = "8.5.15" }
 brigadier = { module = "com.github.Better-than-Adventure:bta-brigadier", version = "1.0.2"}
 slf4j-api = { module = "org.slf4j:slf4j-api", version = "2.0.7" }
 log4j-core = { module = "org.apache.logging.log4j:log4j-core", version.ref = "log4j" }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index fda6420f2..efd246dc4 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -26,9 +26,8 @@ public class SmeltingGenerator {
 
         sharedRecipe("raw_iron_to_iron_ingot", Items.ORE_RAW_IRON.getDefaultStack(), Items.INGOT_IRON.getDefaultStack());
         sharedRecipe("raw_gold_to_gold_ingot", Items.ORE_RAW_GOLD.getDefaultStack(), Items.INGOT_GOLD.getDefaultStack());
-
-        sharedRecipe("dough_to_bread", Items.DOUGH.getDefaultStack(), Items.FOOD_BREAD.getDefaultStack());
-
+        
+        furnaceRecipe("dough_to_bread", Items.DOUGH.getDefaultStack(), Items.FOOD_BREAD.getDefaultStack());
         furnaceRecipe("fish_raw_to_fish_cooked", Items.FOOD_FISH_RAW.getDefaultStack(), Items.FOOD_FISH_COOKED.getDefaultStack());
         furnaceRecipe("porkchop_raw_to_porkchop_cooked", Items.FOOD_PORKCHOP_RAW.getDefaultStack(), Items.FOOD_PORKCHOP_COOKED.getDefaultStack());
         furnaceRecipe("venison_raw_to_venison_cooked", Items.FOOD_VENISON_RAW.getDefaultStack(), Items.FOOD_VENISON_COOKED.getDefaultStack());
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index d6238118b..0e40ec441 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1266,7 +1266,7 @@ class WorkbenchGenerator {
             .setShape(
                 "#X#",
                 "III")
-            .addInput('#', Items.STICK)
+            .addInput('#', Blocks.TORCH_REDSTONE_ACTIVE)
             .addInput('X', Items.DUST_REDSTONE)
             .addInput('I', "minecraft:stones")
             .create("redstone_repeater", new ItemStack(Items.REPEATER, 1));
diff --git a/util/seed-viewer/build.gradle.kts b/util/seed-viewer/build.gradle.kts
index ed88b92e6..73f710b26 100644
--- a/util/seed-viewer/build.gradle.kts
+++ b/util/seed-viewer/build.gradle.kts
@@ -22,6 +22,7 @@ dependencies {
     testImplementation("org.junit.jupiter:junit-jupiter")
 
     implementation(libs.brigadier)?.let { include(it) }
+    implementation(libs.fastutil)?.let { include(it) }
 
     implementation(project(":game:core"))?.let { include(it) }
     implementation(project(":util:logging"))?.let { include(it) }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
index 91030b157..4de727b4c 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
@@ -3,6 +3,7 @@ package org.useless.seedviewer.bta.worldloader;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -88,7 +89,7 @@ public class ChunkLoader implements IChunkProvider {
         chunk.isTerrainPopulated = reader.getIsTerrainPopulated();
         chunk.temperature = reader.getTemperatureMap();
         chunk.humidity = reader.getHumidityMap();
-        Map<Integer, String> biomeRegistry = reader.getBiomeRegistry();
+        Int2ObjectMap<String> biomeRegistry = reader.getBiomeRegistry();
 
         for(int i = 0; i < Chunk.CHUNK_SECTIONS; ++i) {
             ChunkLoaderLegacy.loadChunkSectionFromCompound(chunk.getSection(i), reader, biomeRegistry);
